/*
 * generated by Xtext 2.35.0
 */
package org.tfranke.webservice.dsl.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.tfranke.webservice.dsl.services.WebserviceDSLGrammarAccess;
import webservice.API;
import webservice.BooleanData;
import webservice.ByteData;
import webservice.CollectionDataType;
import webservice.CreateOperation;
import webservice.DeleteOperation;
import webservice.FloatData;
import webservice.IntegerData;
import webservice.ObjectDataType;
import webservice.OtherOperation;
import webservice.ReadOperation;
import webservice.StringData;
import webservice.UpdateOperation;
import webservice.WebservicePackage;

@SuppressWarnings("all")
public class WebserviceDSLSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private WebserviceDSLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == WebservicePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case WebservicePackage.API:
				sequence_API(context, (API) semanticObject); 
				return; 
			case WebservicePackage.BOOLEAN_DATA:
				sequence_BooleanData(context, (BooleanData) semanticObject); 
				return; 
			case WebservicePackage.BYTE_DATA:
				sequence_ByteData(context, (ByteData) semanticObject); 
				return; 
			case WebservicePackage.COLLECTION_DATA_TYPE:
				sequence_CollectionDataType(context, (CollectionDataType) semanticObject); 
				return; 
			case WebservicePackage.CREATE_OPERATION:
				sequence_CreateOperation(context, (CreateOperation) semanticObject); 
				return; 
			case WebservicePackage.DELETE_OPERATION:
				sequence_DeleteOperation(context, (DeleteOperation) semanticObject); 
				return; 
			case WebservicePackage.FLOAT_DATA:
				sequence_FloatData(context, (FloatData) semanticObject); 
				return; 
			case WebservicePackage.INTEGER_DATA:
				sequence_IntegerData(context, (IntegerData) semanticObject); 
				return; 
			case WebservicePackage.OBJECT_DATA_TYPE:
				sequence_ObjectDataType(context, (ObjectDataType) semanticObject); 
				return; 
			case WebservicePackage.OTHER_OPERATION:
				sequence_OtherOperation(context, (OtherOperation) semanticObject); 
				return; 
			case WebservicePackage.PARAMETER:
				sequence_Parameter(context, (webservice.Parameter) semanticObject); 
				return; 
			case WebservicePackage.READ_OPERATION:
				sequence_ReadOperation(context, (ReadOperation) semanticObject); 
				return; 
			case WebservicePackage.STRING_DATA:
				sequence_StringData(context, (StringData) semanticObject); 
				return; 
			case WebservicePackage.UPDATE_OPERATION:
				sequence_UpdateOperation(context, (UpdateOperation) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     API returns API
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         description=EString? 
	 *         url=EString 
	 *         datatypes+=DataType 
	 *         datatypes+=DataType* 
	 *         operations+=Operation 
	 *         operations+=Operation*
	 *     )
	 * </pre>
	 */
	protected void sequence_API(ISerializationContext context, API semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns BooleanData
	 *     BooleanData returns BooleanData
	 *
	 * Constraint:
	 *     (required?='required'? name=EString)
	 * </pre>
	 */
	protected void sequence_BooleanData(ISerializationContext context, BooleanData semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns ByteData
	 *     ByteData returns ByteData
	 *
	 * Constraint:
	 *     (required?='required'? name=EString)
	 * </pre>
	 */
	protected void sequence_ByteData(ISerializationContext context, ByteData semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns CollectionDataType
	 *     CollectionDataType returns CollectionDataType
	 *
	 * Constraint:
	 *     (required?='required'? name=EString listItem=[DataType|EString])
	 * </pre>
	 */
	protected void sequence_CollectionDataType(ISerializationContext context, CollectionDataType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Operation returns CreateOperation
	 *     CreateOperation returns CreateOperation
	 *
	 * Constraint:
	 *     (name=EString description=EString? urlSuffix=EString? response=[DataType|EString]? (parameters+=Parameter parameters+=Parameter*)?)
	 * </pre>
	 */
	protected void sequence_CreateOperation(ISerializationContext context, CreateOperation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Operation returns DeleteOperation
	 *     DeleteOperation returns DeleteOperation
	 *
	 * Constraint:
	 *     (name=EString description=EString? urlSuffix=EString? response=[DataType|EString]? (parameters+=Parameter parameters+=Parameter*)?)
	 * </pre>
	 */
	protected void sequence_DeleteOperation(ISerializationContext context, DeleteOperation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns FloatData
	 *     FloatData returns FloatData
	 *
	 * Constraint:
	 *     (required?='required'? name=EString)
	 * </pre>
	 */
	protected void sequence_FloatData(ISerializationContext context, FloatData semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns IntegerData
	 *     IntegerData returns IntegerData
	 *
	 * Constraint:
	 *     (required?='required'? name=EString)
	 * </pre>
	 */
	protected void sequence_IntegerData(ISerializationContext context, IntegerData semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns ObjectDataType
	 *     ObjectDataType returns ObjectDataType
	 *
	 * Constraint:
	 *     (required?='required'? name=EString datatypes+=[DataType|EString] datatypes+=[DataType|EString]*)
	 * </pre>
	 */
	protected void sequence_ObjectDataType(ISerializationContext context, ObjectDataType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Operation returns OtherOperation
	 *     OtherOperation returns OtherOperation
	 *
	 * Constraint:
	 *     (
	 *         name=EString 
	 *         description=EString? 
	 *         urlSuffix=EString? 
	 *         operation=EString? 
	 *         response=[DataType|EString]? 
	 *         parameters+=Parameter 
	 *         parameters+=Parameter*
	 *     )
	 * </pre>
	 */
	protected void sequence_OtherOperation(ISerializationContext context, OtherOperation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Parameter returns Parameter
	 *
	 * Constraint:
	 *     (required?='required'? description=EString? datatype=[DataType|EString])
	 * </pre>
	 */
	protected void sequence_Parameter(ISerializationContext context, webservice.Parameter semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Operation returns ReadOperation
	 *     ReadOperation returns ReadOperation
	 *
	 * Constraint:
	 *     (name=EString description=EString? urlSuffix=EString? response=[DataType|EString]? (parameters+=Parameter parameters+=Parameter*)?)
	 * </pre>
	 */
	protected void sequence_ReadOperation(ISerializationContext context, ReadOperation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     DataType returns StringData
	 *     StringData returns StringData
	 *
	 * Constraint:
	 *     (required?='required'? name=EString)
	 * </pre>
	 */
	protected void sequence_StringData(ISerializationContext context, StringData semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Operation returns UpdateOperation
	 *     UpdateOperation returns UpdateOperation
	 *
	 * Constraint:
	 *     (name=EString description=EString? urlSuffix=EString? response=[DataType|EString]? (parameters+=Parameter parameters+=Parameter*)?)
	 * </pre>
	 */
	protected void sequence_UpdateOperation(ISerializationContext context, UpdateOperation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
